HDU 3533 Escape (BFS + 预处理)

Escape

Time Limit: 20000/10000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 541    Accepted Submission(s): 141

Problem Description
The students of the HEU are maneuvering for their military training. The red army and the blue army are at war today. The blue army finds that Little A is the spy of the red army, so Little A has to escape from the headquarters of the blue army to that of the red army. The battle field is a rectangle of size m*n, and the headquarters of the blue army and the red army are placed at (0, 0) and (m, n), respectively, which means that Little A will go from (0, 0) to (m, n). The picture below denotes the shape of the battle field and the notation of directions that we will use later.
The blue army is eager to revenge, so it tries its best to kill Little A during his escape. The blue army places many castles, which will shoot to a fixed direction periodically. It costs Little A one unit of energy per second, whether he moves or not. If he uses up all his energy or gets shot at sometime, then he fails. Little A can move north, south, east or west, one unit per second. Note he may stay at times in order not to be shot. To simplify the problem, let’s assume that Little A cannot stop in the middle of a second. He will neither get shot nor block the bullet during his move, which means that a bullet can only kill Little A at positions with integer coordinates. Consider the example below. The bullet moves from (0, 3) to (0, 0) at the speed of 3 units per second, and Little A moves from (0, 0) to (0, 1) at the speed of 1 unit per second. Then Little A is not killed. But if the bullet moves 2 units per second in the above example, Little A will be killed at (0, 1). Now, please tell Little A whether he can escape.
 
Input
For every test case, the first line has four integers, m, n, k and d (2<=m, n<=100, 0<=k<=100, m+ n<=d<=1000). m and n are the size of the battle ground, k is the number of castles and d is the units of energy Little A initially has. The next k lines describe the castles each. Each line contains a character c and four integers, t, v, x and y. Here c is ‘N’, ‘S’, ‘E’ or ‘W’ giving the direction to which the castle shoots, t is the period, v is the velocity of the bullets shot (i.e. units passed per second), and (x, y) is the location of the castle. Here we suppose that if a castle is shot by other castles, it will block others’ shots but will NOT be destroyed. And two bullets will pass each other without affecting their directions and velocities. All castles begin to shoot when Little A starts to escape. Proceed to the end of file.
 
Output
If Little A can escape, print the minimum time required in seconds on a single line. Otherwise print “Bad luck!” without quotes.
 
Sample Input
4 4 3 10 N 1 1 1 1 W 1 1 3 2 W 2 1 2 4 4 4 3 10 N 1 1 1 1 W 1 1 3 2 W 1 1 2 4
 
Sample Output
9 Bad luck!
 
 
 
 
 
非常纠结的一题,做了很久才做出来,题意非常不清楚,不推荐这题。
坑点:有碉堡的点不能走,人不会往回走,终点可能有碉堡。
先把所有可能被炮弹打到的点以及它被炮弹打到的时间标记出来,时间上限是初始能量值,因为超过了这个值就不能再走了,标记也就没意义。然后bfs搜的时候,用VIS[x][y][t]来判重,即当前点是否在第t秒以及走过了,我还加入了个曼哈顿距离来剪枝,如果当前点的剩余能量小于到终点的曼哈顿距离,那么就剪掉。
注意,更新x和y的时候,不必考虑向西和向北,因为终点是在东南方,刚开始我不确定这样对不对,但是去掉这两个点后依然能A,当然,也许是数据不够强,某个角落里还存在着一组诡异的数据,需要先绕回去几步,谁知道呢。
 
  1 #include <iostream>
  2 #include <cstdio>
  3 #include <queue>
  4 using    namespace    std;
  5 
  6 const    int    SIZE = 105;
  7 const    int    UPDATE[][2] = {{1,0},{0,1},{0,0}};
  8 int    N,M,K,E;
  9 bool    FIRE[SIZE][SIZE][1005];
 10 bool    VIS[SIZE][SIZE][1005];
 11 bool    CASTLE[SIZE][SIZE];
 12 struct    Node
 13 {
 14     int    x,y,t,e;
 15     bool    check(void)
 16     {
 17         if(x < 0 || x > N || y < 0 || y > M || t > E || VIS[x][y][t] || CASTLE[x][y] ||
 18           FIRE[x][y][t] || !e || N - x + M - y > e)
 19             return    false;
 20         return    true;
 21     }
 22 };
 23 struct    Cas
 24 {
 25     char    ch;
 26     int    t,v,x,y;
 27 };
 28 
 29 void    deal(char ch,int t,int v,int x,int y);
 30 void    bfs(void);
 31 int    main(void)
 32 {
 33     Cas    temp[105];
 34     while(scanf("%d%d%d%d",&N,&M,&K,&E) != EOF)
 35     {
 36         fill(&FIRE[0][0][0],&FIRE[SIZE - 1][SIZE - 1][1004],false);
 37         fill(&VIS[0][0][0],&VIS[SIZE - 1][SIZE - 1][1004],false);
 38         fill(&CASTLE[0][0],&CASTLE[SIZE - 1][SIZE - 1],false);
 39 
 40         for(int i = 0;i < K;i ++)
 41         {
 42             scanf(" %c%d%d%d%d",&temp[i].ch,&temp[i].t,&temp[i].v,&temp[i].x,&temp[i].y);
 43             CASTLE[temp[i].x][temp[i].y] = true;
 44         }
 45         if(CASTLE[N][M])
 46         {
 47             puts("Bad luck!");
 48             continue;
 49         }
 50         for(int i = 0;i < K;i ++)
 51             deal(temp[i].ch,temp[i].t,temp[i].v,temp[i].x,temp[i].y);
 52         bfs();
 53     }
 54 
 55     return    0;
 56 }
 57 
 58 void    deal(char ch,int t,int v,int x,int y)
 59 {
 60     if(ch == 'W')
 61     {
 62         int    stop = 0;
 63         for(int j = y - 1;j >= 0;j --)
 64             if(CASTLE[x][j])
 65             {
 66                 stop = j;
 67                 break;
 68             }
 69         for(int j = y - v,ini = 1;j >= stop;j -= v,ini ++)
 70             for(int k = ini;k <= E;k += t)
 71                 FIRE[x][j][k] = true;
 72 
 73     }
 74     else    if(ch == 'E')    
 75     {
 76         int    stop = M;
 77         for(int j = y + 1;j <= M;j ++)
 78             if(CASTLE[x][j])
 79             {
 80                 stop = j;
 81                 break;
 82             }
 83 
 84         for(int j = y + v,ini = 1;j <= stop;j += v,ini ++)
 85             for(int k = ini;k <= E;k += t)
 86                 FIRE[x][j][k] = true;
 87     }
 88     else    if(ch == 'N')
 89     {
 90         int    stop = 0;
 91         for(int j = x - 1;j >= 0;j --)
 92             if(CASTLE[j][y])
 93             {
 94                 stop = j;
 95                 break;
 96             }
 97         for(int j = x - v,ini = 1;j >= stop;j -= v,ini ++)
 98             for(int k = ini;k <= E;k += t)
 99                 FIRE[j][y][k] = true;
100     }
101     else    if(ch == 'S')    
102     {
103         int    stop = N;
104         for(int j = x + 1;j <= N;j ++)
105             if(CASTLE[j][y])
106             {
107                 stop = j;
108                 break;
109             }
110         for(int j = x + v,ini = 1;j <= stop;j += v,ini ++)
111             for(int k = ini;k <= E;k += t)
112                 FIRE[j][y][k] = true;
113     }
114 }
115 
116 void    bfs(void)
117 {
118     Node    first;
119     first.x = first.y = first.t = 0;
120     first.e = E;
121     queue<Node>    que;
122     que.push(first);
123     VIS[0][0][0] = true;
124 
125     while(!que.empty())
126     {
127         Node    cur = que.front();
128         que.pop();
129 
130         for(int i = 0;i < 3;i ++)
131         {
132             Node    next = cur;
133             next.x += UPDATE[i][0];
134             next.y += UPDATE[i][1];
135             next.t ++;
136             next.e --;
137             if(!next.check())
138                 continue;
139             if(next.x == N && next.y == M)
140             {
141                 printf("%d
",next.t);
142                 return    ;
143             }
144             VIS[next.x][next.y][next.t] = true;
145             que.push(next);
146         }
147     }
148     puts("Bad luck!");
149 }
原文地址:https://www.cnblogs.com/xz816111/p/4394104.html